//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "batchIt.h"
#include "CZT_FeatureCalc.h"
#include "CZT_FeatureImage.h"
#include "CZT_PcmEq.h"
#include "options3.h"
#include "records.h"
#include "start.h"
#include "animals.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SDL_NumLab"
#pragma link "SDL_rchart"
#pragma link "SDL_plot3d"
#pragma resource "*.dfm"
#define kList1  0
#define kList2  1
#define Xs              1
#define Ys              2
#define Xe              3
#define Ye              4
#define Val             5
#define ValidComp       6

Tbatch *batch;

//---------------------------------------------------------------------------
__fastcall Tbatch::Tbatch(TComponent* Owner)
        : TForm(Owner)
{
  derivTB->Brush->Color=clYellow;
  entropyTb->Brush->Color=clRed;
  sldrBrightness->Brush->Color=(TColor)RGB(0,0,0);//clBlack;
  counting=false;
  option->save_all=false;
  option->save_image_mem=false;
  option->custom_parse=false;
  option->brain_mode=false;
  option->raw_feature_folder=raw_features1->Text;
  Sonogram=new Graphics::TBitmap();
  RecordFile1->Caption=DataForm->Records->TableName;
  DataForm->Records->Active=true;
  option->syllable_table_name=DataForm->Records->TableName;
  RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
  //DataForm->CountRecsClick(this);
  //RecordsNum->Caption=DataForm->recNum;
  option->bird_ID="none";
  option->chan=0;
  option->move_sound=false;
  option->delete_trash_file=false;
  option->create_feature_arrays=true;//false;
  option->refine_segmentation=false;
  option->keep_file_name=true;
  option->keep_original_rawfile_name=true;
  option->select_table=0;
  option->format->ItemIndex=format->ItemIndex;
  DataForm->MyConnection1->Database="SAP";
 // DataForm->settings->TableName="settings";
  DataForm->settings->Active=true;
  slave_chans=0;
  got_data=false;
  //DataForm->new_raw_table("raw_features_default");
  option->format->ItemIndex=1;//get serial number and time from file age...
  option->bitmapHeight=256;
  option->squiz=2;
  m_Calculator.m_Image.m_nMaxSlices=10000;
  ActiveList=kList1;
  DataForm->file_table_name="file_table";
  if (!DirectoryExists("c:\\SAP\\tmpSound\\"))ForceDirectories("c:\\SAP\\tmpSound\\");
  if (!DirectoryExists("c:\\SAP\\raw_features\\"))ForceDirectories("c:\\SAP\\raw_features\\");
  DirectoryListBox1->Directory = "c:\\sap\\sounds";
   try{
    derivTB->Position=DataForm->Retrieve(1, "deriv_thresh").ToInt();
    option->amplitude_thresh=(125-derivTB->Position);
    entropyTb->Position=DataForm->Retrieve(1, "entropy_thresh").ToInt();
    option->entropy_thresh=(float)(-entropyTb->Position)/50.0;
   }
   catch(...)
  {
	Application->MessageBox(L"could not open the settings table, default settings will be applied", NULL, MB_OK);

  }
  data_typeClick(this);
}

//---------------------------------------------------------------------------
void Tbatch::Calc(AnsiString fileName)
{

   //  CWavIterator wave[1];
     //CWavIterator* wv[1];
     //wv[0]=&wave;
     if(option->halt){doit=false; return;}

    // m_Calculator.ResetContents();
   //  if(data_type->ItemIndex) // calculate the binary files instead of sounds
   //  {
   //    if(m_Calculator.do_binary(fileName)) m_Calculator.save_to_database(0);
   //    return;
   //  }
    // int ch=slave_chans;
    // if(!found_slaves && !wait_for_slaves)ch=0;
     CZT_PcmEq equalizer;
     if(wave_files[0].OpenFile(fileName.c_str()) != pcmpos_error)
     {
          SoundFile=fileName;
          if(equalize->Checked) wave_files[0].UseFilter(equalizer);

          if( m_Calculator.Calculate(wave_files,slave_chans-deduct)) // option->save_all ||  deduct a missing slave if needed...
          {
             if(calc_state_dur->Checked)
             {
                float similarity_reject_thresh=state_transition_Num->Value;
                m_Calculator.note_dur(similarity_reject_thresh, missmatchesTb->Position);
             }
             m_Calculator.save_to_database(0); // this is the main function...
			 rec1->Color=(TColor)RGB(0,0,0);//clBlack;
             rec1->Caption="Accepted";
             files_accepted++;
             files_acceptedN->Caption=files_accepted;
             msCounter+=option->ms_recordes_added;
             msCounterN->Caption=msCounter;
             file_table_index->Value++;
             if(do_rhythm->Checked)calc_rhythmClick(this);
          }
          else
          {
                rec1->Color=clGreen;
                rec1->Caption="Rejected";
              /*  if(num_slaves)
                {
                        for(int i=0; i<m_Calculator.slices; i++) delete[] m_Calculator.slave_chans[i];
                        delete[] m_Calculator.slave_chans;
                } */
          }

          max_syll_dur->Value=option->advanceTb->Value*m_Calculator.maxSyllableDur;
          max_bout_dur->Value=option->advanceTb->Value*m_Calculator.maxBoutDur;
          syllable_num->Value=m_Calculator.syllable_number;
          if(Draw1->Down)
          {
            m_Calculator.render_image=true;
            m_Calculator.GetImage().DrawAllSlices(Image1);
            Sonogram->Assign(Image1->Picture->Bitmap);
           // ScrollBox1->HorzScrollBar->Position=(ScrollBox1->HorzScrollBar->Range
           //                                       *m_Calculator.bout_end / m_Calculator.total_frames)
           //                                       -m_Calculator.maxBoutDur;
          }
          else m_Calculator.render_image=false;


     }
 }

//---------------------------------------------------------------------------
void __fastcall Tbatch::SingleFileClick(TObject *Sender)
{
   slave_chans=0;
   Screen->Cursor = crHourGlass;
   int ind=save1->ItemIndex;
   save1->ItemIndex=3;
   DataForm->Records->Active=true;
   option->halt=false;
   Draw1->Down=true;
   //OpenDialog1->DefaultExt="*.wav";
  // OpenDialog1->Filter="sound files|*.wav";
  // show_sonogram->Checked=true;
   m_Calculator.render_image=true;
   if(soundList->Items->Count)
   {
    option->moveTo_sound_folders[0]=target_sound_file_folder->Text;
     entropyTbChange(this);
     derivTBChange(this);
     m_Calculator.RenderImage(1);
     option->wave_names[0]=soundList->FileName;
     option->extract_file_attributes();
     Calc(soundList->FileName);
     RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
     total_count+=option->syllCounter;
     counter->Caption=total_count;
   }
   else  MessageDlg("could not open sound file -- please click on a file!", mtInformation, TMsgDlgButtons() << mbOK, 0);
   save1->ItemIndex=ind; // back to normal mode
   Screen->Cursor = crDefault;
}


// This method is activated when the application is idle, and at that time, the batch can make a step.
// batch is activated by the 'doit' global variable.
// for a limited number of operations (do next x files), batch is also conditionsed by the counting global variable.

//---------------------------------------------------------------------------
 /*
void __fastcall Tbatch::MyIdleHandler(TObject *Sender, bool &Done)
{
  try{


        if(counting){back_count--; if(back_count<1){counting=false; doit=false;}} // this will set a limit to number of operations in do next x files mode
        if(table_batch && doit) do_table_batch();
        else if(soundList->ItemIndex<soundList->Items->Count-1 && doit)  processFile(); // make a step, processing next file
        else if(doit) // All the files in the folder where processed
        {
            if(All_subfolders->Checked)// continue across all subfolders
            {
              if(FileListBox1->ItemIndex<FileListBox1->Items->Count-1)
              {
                 FileListBox1->ItemIndex++; // change subfolder
                 FileListBox1Click(this);   // get the files exstracted to 'soundlist'
                 FileListBox1Change(this);
                 Sleep(100);
                 FileListBox1->Refresh();
                 Sleep(100);
                 FileListBox1Change(this);
                // set_slave_directory(1, slave_list1, folder_name1);
                // option->slave_mode[0]=slave_state1->ItemIndex;
  

              }
              else
              {
                doit=false;  // finish the batch
                stop = GetTickCount();
                int dur=stop-start;
                AnsiString sMessage;
                sMessage.printf("done within %d seconds",dur/1000);
                MessageDlg(sMessage.c_str(), mtInformation, TMsgDlgButtons() << mbOK, 0);
                RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
              }
            }

            else
            {
              st->Brush->Color=clGreen;
              doit=false;
              stop = GetTickCount();
              int dur=stop-start;
              AnsiString sMessage;
              sMessage.printf("done within %d seconds",dur/1000);
              MessageDlg(sMessage.c_str(), mtInformation, TMsgDlgButtons() << mbOK, 0);
              RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
            }
        }
     }catch(...)
       {
           doit=false;
           MessageDlg("an exception has occured, could not finish the batch",mtWarning, TMsgDlgButtons() << mbOK, 0);
       }
}

*/
void Tbatch::processFile()
{
        if(!first_time) soundList->ItemIndex++;
        files_processedN->Caption=files_processed;
        SoundFile=soundList->FileName;
        option->wave_names[0]=SoundFile;
        num_slaves=lookfor_slave_files();

        if(wait_for_slaves->ItemIndex && count_slaves() && !num_slaves)
        {
          if(!first_time)soundList->ItemIndex--;
          st->Brush->Color=clRed;
          status->Caption="executing batch";
          return;
        }
        if(first_time) first_time=false;
        // else soundList->ItemIndex++;
        st->Brush->Color=clRed;
        status->Caption="executing batch";
     // AnsiString soundFile=soundList->FileName;
        option->extract_file_attributes();
        if(auto_name->Checked && oldDay!=option->day)
        {
          int bird_age= option->file_age - (int)hatched->Date;
          if(bird_age<0)bird_age=0;
          /*&& !ignore_errors->Checked)
          {
             if (MessageDlg("Bird age is negative! The hatching date might be wrong or 'extract time stamp' is not giving the correct file age. Continue the batch anyway?", mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes)
             {
                Application->MessageBox("The batch is now terminated.", NULL, MB_OK);
                return;
             }
             else
             {
                ignore_errors->Checked=true;
                Application->MessageBox("The batch will now continue. Note that 'ignore errors' next to 'hatching date' is now checked and negative ages will apear in the tables.", NULL, MB_OK);
             }

          }// str=RecordFile1->Caption+"_" + bird_age;

          */
          str="raw_" + bird_name->Caption +"_" + bird_age;
          if((save1->ItemIndex==0 || save1->ItemIndex==2) && !DataForm->table_exists(str))
          {
                m_Calculator.last_ms_record=0;
                str=DataForm->new_raw_table(str,slave_chans);
          }
          else // table exists
          {   // but the slave_chans do not exist!
              if((save1->ItemIndex==0 || save1->ItemIndex==2) && slave_chans && !DataForm->chans_exist(str, slave_chans))
              {
                m_Calculator.last_ms_record=0;
                str=DataForm->new_raw_table(str,slave_chans); // create a new raw table
              }
          }
          raw_features1->Text=str;
          ms_table_name->Caption=str;
          option->features_table=str;
         // new_raw_table(str, int num_slaves)
          oldDay=option->day;

        }

        files_processed++;
        Calc(SoundFile); // this will also do:  m_Calculator.save_to_database();
        
        total_count+=option->syllCounter;
        counter->Caption=total_count;
        counter->Repaint();
        batch->Refresh();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


void __fastcall Tbatch::FormClose(TObject *Sender, TCloseAction &Action)
{
        option->show_start=true;
        StartForm->Visible=true;
        delete Sonogram;
       // delete batch;
}



void __fastcall Tbatch::FormCreate(TObject *Sender)
{
   doit=false;
   //Application->OnIdle = MyIdleHandler;
   PitchBClick(this);
   EntropyBClick(this);
   FMBClick(this);
   AMClick(this);
   PeakFrBClick(this);
   PitchGoodnessBClick(this);
   sldrBrightnessChange(this);
   option->Draw_sonogram=false;
}


// this method only activates the batch by setting the global variable 'doit' to true.
// to see the activation of batch routines, go to the MyIdleHandler method. This indirection
// is an alternative to setting a seperate thread, allowing user to stop the batch.
void __fastcall Tbatch::batchClick(TObject *Sender)
{
        breakIt->Enabled=true;
        files_processed=0;
        files_processedN->Caption=0;
        files_accepted=0;
        msCounter=0;
        files_acceptedN->Caption=0;
        SoundFile=soundList->FileName;
        option->wave_names[0]=SoundFile;
        option->extract_file_attributes();
        Draw1Click(this);
        if(auto_file_table->Checked)
        {
          str="file_table_"; str+=bird_name->Caption;//syllable_table_name->Caption;
          DataForm->file_table_name=str;
          DataForm->Create_File_Table();
          file_table_name->Caption=str;
        }

        int bird_age= option->file_age - (int)hatched->Date;
        if(bird_age<0)bird_age=0; //{Application->MessageBox("bird age can't be negative!", NULL, MB_OK);return;}

        batch_controls->ActivePage=progress;//->Visible=false;
      /*
        str=option->syllable_table_name;
        if(str[1]=='s' && str[2]=='y' && str[3]=='l' && str.Length()>6)
                        str="raw_" + str.SubString(6,str.Length()-6);
        str+="_";
        str+=bird_age;
        raw_features1->Text=str;
      */
        slave_chans=count_slaves();
        slave_numL->Caption=slave_chans;
        save1Click(this);
        if(save1->ItemIndex==3)MessageDlg("Warning: Are you sure? The save option is off and no data will be saved...", mtWarning, TMsgDlgButtons() << mbOK, 0);
        first_time=true;
        option->halt=false;
        DataForm->Records->Active=true;

        option->bird_ID = bird_name->Caption;//;InputBox("Sound Analysis Pro", "Animal ID:", "Please type animal identification number");
        //option->bird_ID=str.ToIntDef(0);
        if(option->bird_ID=="")return;

         entropyTbChange(this);
         derivTBChange(this);
         //Draw1->Down=false;
         start=GetTickCount();
    //     show_sonogram->Checked=false;
         m_Calculator.render_image=false;
         file_table_index->Value=DataForm->update_file_table_index(0);
         doit=true;
         RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
}


void __fastcall Tbatch::derivTBChange(TObject *Sender)
{
  if(live_update->Down)
  {
    EntropyB->Down=true;
    DerivPowerB->Down=true;
    int pos=derivTB->Position;
    option->amplitude_thresh=125-derivTB->Position;
    m_Calculator.GetImage().DrawAllSlices(Image1);
    Image1->Canvas->Pen->Color=clYellow;
    Image1->Canvas->MoveTo(0,pos);
    Image1->Canvas->LineTo(Image1->Width,pos);
    deriv_val->Value=125-derivTB->Position;
  }
  else
  {
    Image1->Picture->Bitmap=Sonogram;
    int pos=derivTB->Position;
    option->amplitude_thresh=125-derivTB->Position;
    Image1->Canvas->Pen->Color=clYellow;
    Image1->Canvas->MoveTo(0,pos);
    Image1->Canvas->LineTo(Image1->Width,pos);
    deriv_val->Value=125-derivTB->Position;
  }
  DataForm->Settings(1, "deriv_thresh", derivTB->Position);
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::stretchClick(TObject *Sender)
{
if(stretch->ItemIndex)
       {Image1->AutoSize=true;Image1->Stretch=false;}
  else {Image1->AutoSize=false; Image1->Stretch=true; Image1->Width=ScrollBox1->Width-10;  }
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::sldrBrightnessChange(TObject *Sender)
{
 float bright=exp((float)sldrBrightness->Position/700);
 m_Calculator.GetImage().SetBrightness(bright);//float(sldrBrightness->Position/39.0625));
     m_Calculator.GetImage().DrawAllSlices(Image1);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::batch_countClick(TObject *Sender)
{
  breakIt->Enabled=true;
  files_processed=0;
  files_processedN->Caption=0;
  files_acceptedN->Caption=0;
  msCounter=0;
  batch_controls->ActivePage=progress;
  Draw1Click(this);
  //batch_controls->Visible=false;

  if(auto_file_table->Checked)
  {
    str="file_table_"; str+=bird_name->Caption;//syllable_table_name->Caption;
    DataForm->file_table_name=str;
    DataForm->Create_File_Table();
    file_table_name->Caption=str;
  }

  slave_chans=count_slaves();
  slave_numL->Caption=slave_chans;
  if(save1->ItemIndex==3)MessageDlg("Warning: Are you sure? The save option is off and no data will be saved...", mtWarning, TMsgDlgButtons() << mbOK, 0);
  first_time=true;
  option->halt=false;
  DataForm->Records->Active=true;
   {
     str = InputBox("Sound Analysis Pro", "Animal name:", "Please type animal name (e.g., R109");
     option->bird_ID=str;//.ToIntDef(0);
     if(option->bird_ID=="")return;
   }
   //Draw1->Down=false;
   entropyTbChange(this);
   derivTBChange(this);
   start=GetTickCount();
   m_Calculator.render_image=false;
   back_count=back_counter->Position;
   counting=true;
   DataForm->update_file_table_index(0);
   doit=true;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::entropyTbChange(TObject *Sender)
{

  if(live_update->Down)
  {
    EntropyB->Down=true;
    DerivPowerB->Down=true;
    int pos=entropyTb->Position/3.6;
    option->entropy_thresh=(float)(-entropyTb->Position)/50.0;
    entropy_val->Value=(float)-entropyTb->Position/50;
    m_Calculator.GetImage().DrawAllSlices(Image1);
    Image1->Canvas->Pen->Color=clRed;
    Image1->Canvas->MoveTo(0,pos);
    Image1->Canvas->LineTo(Image1->Width,pos);
    Image1->Canvas->Pen->Color=clYellow;
    pos=derivTB->Position;
    Image1->Canvas->MoveTo(0,pos);
    Image1->Canvas->LineTo(Image1->Width,pos);

  }
  else
  {
    Image1->Picture->Bitmap=Sonogram;
    int pos=entropyTb->Position/3.6;
    option->entropy_thresh=(float)(-entropyTb->Position)/50.0;
    Image1->Canvas->Pen->Color=clRed;
    Image1->Canvas->MoveTo(0,pos);
    Image1->Canvas->LineTo(Image1->Width,pos);
    Image1->Canvas->Pen->Color=clYellow;
    pos=derivTB->Position;
    Image1->Canvas->MoveTo(0,pos);
    Image1->Canvas->LineTo(Image1->Width,pos);
    entropy_val->Value=(float)-entropyTb->Position/100.0;
  }
  DataForm->Settings(1, "entropy_thresh", entropyTb->Position);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::save1Click(TObject *Sender)
{
        switch(save1->ItemIndex)
       {
         case 0:option->saveRawFile=true;
                option->saveRecFiles=true;
                m_Calculator.last_ms_record=0;
                DataForm->new_raw_table(raw_features1->Text, slave_chans);
                ms_table_name->Caption=raw_features1->Text;//str;
                batch_saving->Caption="syllable and raw features tables";
                break;
         case 1:option->saveRawFile=false; option->saveRecFiles=true;
                batch_saving->Caption="syllable table";
                break;
         case 2:option->saveRawFile=true; option->saveRecFiles=false;
                m_Calculator.last_ms_record=0;
                DataForm->new_raw_table(raw_features1->Text, slave_chans);
                ms_table_name->Caption=raw_features1->Text;//str;
                batch_saving->Caption="raw features tables";
                break;
         case 3:option->saveRawFile=false; option->saveRecFiles=false;
                batch_saving->Caption="nothing";
       }
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::PitchBClick(TObject *Sender)
{

       m_Calculator.GetImage().GetPitch().bRender = false;
       m_Calculator.GetImage().GetEntropy().bRender = true;
       m_Calculator.GetImage().GetFM().bRender = false;
       m_Calculator.GetImage().GetAM().bRender = false;
       m_Calculator.GetImage().GetDerivPow().bRender = true;
       m_Calculator.GetImage().Getmfa().bRender = false;
       m_Calculator.GetImage().GetPitchGoodness().bRender = false;
       m_Calculator.GetImage().GetPeakFreq().bRender = false;
       m_Calculator.GetImage().Getcepst0().bRender = false;
       m_Calculator.GetImage().Getcontinuity_t().bRender = false;
       m_Calculator.GetImage().Getcontinuity_f().bRender = false;
       m_Calculator.GetImage().Getprincipal_frequency().bRender = false;
       m_Calculator.GetImage().Getslope().bRender = false;

}
//---------------------------------------------------------------------------

void __fastcall Tbatch::EntropyBClick(TObject *Sender)
{
     m_Calculator.GetImage().GetEntropy().bRender = EntropyB->Down;
     m_Calculator.GetImage().DrawAllSlices(Image1);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::FMBClick(TObject *Sender)
{
     m_Calculator.GetImage().GetFM().bRender = FMB->Down;
     m_Calculator.GetImage().DrawAllSlices(Image1);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::PeakFrBClick(TObject *Sender)
{
     m_Calculator.GetImage().GetPeakFreq().bRender = PeakFrB->Down;
     m_Calculator.GetImage().DrawAllSlices(Image1);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::PitchGoodnessBClick(TObject *Sender)
{
     m_Calculator.GetImage().GetPitchGoodness().bRender = PitchGoodnessB->Down;
     m_Calculator.GetImage().DrawAllSlices(Image1);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::DerivPowerBClick(TObject *Sender)
{
m_Calculator.GetImage().GetDerivPow().bRender = DerivPowerB->Down;
     m_Calculator.GetImage().DrawAllSlices(Image1);
}
//---------------------------------------------------------------------------



void __fastcall Tbatch::breakItClick(TObject *Sender)
{
  //batch_controls->Visible=true;
  breakIt->Enabled=false;
  doit=false;
  option->custom_parse=false;
  st->Brush->Color=clGreen;
  status->Caption="The batch is now complete";
  RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
}
//---------------------------------------------------------------------------



void __fastcall Tbatch::back_counterChange(TObject *Sender)
{
  files_to_do->Value=back_counter->Position;
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::save_optionsClick(TObject *Sender)
{
  //if(save_options->ItemIndex)option->saveRecFiles=true;
 // else option->saveRecFiles=false;
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::raw_features1Change(TObject *Sender)
{
  option->raw_feature_folder=raw_features1->Text;
}
//---------------------------------------------------------------------------



void __fastcall Tbatch::BitBtn2Click(TObject *Sender)
{
  option->Visible=true;
  option->BringToFront();
  option->show_start=false;
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::Delete_recsClick(TObject *Sender)
{
  if (MessageDlg("Are you sure? All records will be deleted!", mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes)
  {
    DataForm->Records->Active=false;
    DataForm->Records->EmptyTable();
    DataForm->Records->Active=true;
    RecordFile1->Caption=option->syllable_table_name;
    RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
  }
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::move_sound_fileClick(TObject *Sender)
{
  if(move_sound_file->Checked)
  {
     option->moveTo_sound_folders[0]=target_sound_file_folder->Text;
     test_folderClick(this);
     option->move_sound=true;
     sound_output1->Enabled=true;
     target_sound_file_folder->Enabled=true;
     test2->Enabled=true;
  }

  else
  {
    option->move_sound=false;
    sound_output1->Enabled=false;
    target_sound_file_folder->Enabled=false;
    test2->Enabled=false;
  }
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::delete_original_soundClick(TObject *Sender)
{
  if(delete_original_sound->Checked)option->delete_trash_file=true;
  else option->delete_trash_file=false;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::test_folderClick(TObject *Sender)
{
if (!DirectoryExists(option->moveTo_sound_folders[0]))
		{if(!ForceDirectories(option->moveTo_sound_folders[0])) Application->MessageBox(L"Sorry, cannot create folder. Please check if disk is accessible", NULL, MB_OK);
		  else Application->MessageBox(L"Folder created, Okay!", NULL, MB_OK);
        }
   else Application->MessageBox(L"Folder in place, Okay!", NULL, MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::target_sound_file_folderChange(TObject *Sender)
{
  option->moveTo_sound_folders[0]=target_sound_file_folder->Text;
}
//---------------------------------------------------------------------------





void __fastcall Tbatch::sound_detection_termsClick(TObject *Sender)
{
  if(sound_detection_terms->ItemIndex)
       {  option->entropy_and_power=false; option->entropy_or_power=true;}
  else {  option->entropy_and_power=true;  option->entropy_or_power=false;}
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::data_typeClick(TObject *Sender)
{
     if(data_type->ItemIndex)  // two pannels
     {
         FileListBox1->Visible=true;
         label4->Visible=true;
         All_subfolders->Visible=true;
         All_subfolders->Checked=true;
         soundList->Top=328;
         soundList->Height=129;
         DirectoryListBox1->FileList=FileListBox1;
     }
     else                     // one pannel
     {
        FileListBox1->Visible=false;
        label4->Visible=false;
        All_subfolders->Checked=false;
        All_subfolders->Visible=false;
        soundList->Top=176;
        soundList->Height=280;
        DirectoryListBox1->FileList=soundList;
     }
//   if(data_type->ItemIndex){soundList->Mask="*.dat";option->format->ItemIndex=0;}
 //  else {soundList->Mask="*.wav";option->format->ItemIndex=1;}
}
//---------------------------------------------------------------------------




void __fastcall Tbatch::Draw1Click(TObject *Sender)
{
  if(Draw1->Down)
  {
       m_Calculator.render_image=true; m_Calculator.RenderImage(1);

  }
  else {m_Calculator.render_image=false;  m_Calculator.RenderImage(0);}
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::rawfile_nameClick(TObject *Sender)
{
  if(rawfile_name->ItemIndex)option->keep_original_rawfile_name=false;
  else option->keep_original_rawfile_name=true;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::warning1Click(TObject *Sender)
{
MessageDlgPos("Warning: Before running the batch you must set appropriate derivative and entropy thresholds (see yellow and red track-bars). Otherwise, segmentation will be meaningless (trush in -- trush out). \r Try the 'Do one file' mode first without saving.", mtWarning, TMsgDlgButtons() << mbOK, 0, 10,250);

}
//---------------------------------------------------------------------------
    

void __fastcall Tbatch::BitBtn3Click(TObject *Sender)
{
soundList->Directory=Edit1->Text;         
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::Edit1Click(TObject *Sender)
{
   Edit1->Clear();
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::new_tableClick(TObject *Sender)
{
  batch->Enabled=true;
  batch_count->Enabled=true;
  database=DataForm->MyConnection1->Database;
  //DataForm->new_tableClick(this);
  str = InputBox("Bird name", "Insert Bird Name:", "bird");
  bird_name->Caption=str;//DataForm->TheTable->TableName;
  option->saveRawFile=false;
  update_table_names();

}
//---------------------------------------------------------------------------

void __fastcall Tbatch::toExcelClick(TObject *Sender)
{
  DataForm->ToExelClick(this);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::toMatlabClick(TObject *Sender)
{
  DataForm->Visible=true;
  DataForm->BringToFront();
  DataForm->show_start=false;
  DataForm->datapages->ActivePageIndex=1;
}
//---------------------------------------------------------------------------



void __fastcall Tbatch::sound_output1Click(TObject *Sender)
{
   OpenDialog1->FileName="not relevant";
   if(OpenDialog1->Execute()) target_sound_file_folder->Text=ExtractFileDir(OpenDialog1->FileName)+"\\";

}
//---------------------------------------------------------------------------

void __fastcall Tbatch::features_output1Click(TObject *Sender)
{

     str = InputBox("Sound Analysis Pro", "raw features table:", "Please type raw-feature table name, starting with a letter");
     m_Calculator.last_ms_record=0;
     DataForm->new_raw_table(str, count_slaves());
     raw_features1->Text=str;
     ms_table_name->Caption=str;
     option->features_table=str;
   
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::test2Click(TObject *Sender)
{
if (!DirectoryExists(option->moveTo_sound_folders[0]))
        {
		  if(!ForceDirectories(option->moveTo_sound_folders[0])) Application->MessageBox(L"Sorry, cannot create sound data folder. Please check if disk is accessible", NULL, MB_OK);
          else MessageDlg("Folder created for sound data, Okay!", mtInformation, TMsgDlgButtons() << mbOK, 0);

        }
   else MessageDlg("Folder for sound data is in place, Okay!", mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn10Click(TObject *Sender)
{
  str="Once you analyzed sound data and saved the raw features in a binary file \r";
  str+="you may use that file to re-analyze your data very quickly. \r \r";
  str+="For example, you may want to re-segment your sound to syllables using a variety \r";
  str+="of parameter setting (e.i., using differet values of 'derivative power threshold \r";
  str+="Perfoming this analysis on the binary files (as opposed to the sound files) can save \r";
  str+="about 90% of the computation time.";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);

}
//---------------------------------------------------------------------------

void __fastcall Tbatch::set_slavesClick(TObject *Sender)
{
  batch_controls->ActivePage=TabSheet3;
 /*
  str="Sound Analysis use MySQL tables to store syllable features. The default table for storing the data \r";
  str+="is 'recs0'. Obviously, it is better to set a different table for each experiment. \r \r";
  str+=" * If you already created such a table, you can open it by clicking 'change table'. \r \r";
  str+=" * You can create a new table by clicking 'new table' based on a tamplete table \r \r";
  str+="   It is esential to select the appropriate template, we strongly recomend you use either \r";
  str+="      -- 'syll_tamplete' to create a new empty table \r";
  str+="      -- a table name you already used, in such a case, the new table will contain both \r";
  str+="          the format (fields) and the data of the existing table. \r";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
  */
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::help5Click(TObject *Sender)
{
  str=" It is very important to first try the segmentation based analysis in single file. \r";
  str+=" This is important even if you are only interested in the raw feature file, since \r";
  str+="Sound Analysis uses the segmentation to decide if the file contain animal sound of not.\r \r";
  str+="The batch will segment the sound, and compute  mean and variance feature values \r";
  str+="based on the segmentation. We use two criteria for segmentation: the power of spectral \r";
  str+="derivaties and the value of Wiener entropy. you should manipulate those using the red and \r";
  str+="the yellow sliders, while observing the blue (syllable) and red (bout) outlines under the \r";
  str+="spectral image, while the 'Live update' button is pressed down.";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn4Click(TObject *Sender)
{
  str="Sound Analysis can save both raw and segmented features:";
  str+="1. The feaures of each segmented syllable are saved to a table";
  str+="2. The raw features of each FFT time window can be save to a binary file.";
  str+="     Those files can be then used to re-segment syllables, as if the  sound";
  str+="     has been re-analyzed, but much faster.";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::BitBtn6Click(TObject *Sender)
{
  str="When this option is selected, all the files that where 'accepted' as relevant are moved";
  str+="to the folder you select. Note that if your sounds cannot be moved, they will be copied.";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn9Click(TObject *Sender)
{
  str="Plesae select sampling rate. This version of Sound Analysis only support sounds sampled at these rates";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::help10Click(TObject *Sender)
{
  str="These two sliders control the segmentation of the sound to syllable and bout units. \r ";
  str+="Syllable units are underlined by a light blue color, and bouts are underlined by a red color.\r";
  str+="Note that additional constraints on segmentation are set in the option pages. In particular, \r";
  str+="if 'minimum peak frequency' in 'detection of animal sound' is lower than a threshold, sound \r";
  str+="wont be considered as a syllable regardless of these threshold settings. \r \r";
  str+="Note that derivative power and Wiener entropy thresholds can be related by 'or/end'.  \r";
  str+="That is, segmentation can be done by satisfying either one or both thresholds.";
  MessageDlgPos(str, mtInformation, TMsgDlgButtons() << mbOK, 0, 140,162);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::AMClick(TObject *Sender)
{
     m_Calculator.GetImage().GetAM().bRender = AM->Down;
     m_Calculator.GetImage().DrawAllSlices(Image1);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::start_formBClick(TObject *Sender)
{
StartForm->Visible=true;
   StartForm->BringToFront();          
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::save_allClick(TObject *Sender)
{
    if(save_all->Checked){ option->save_all=false; saving_thresh->Visible=true;}
    else{ option->save_all=true; saving_thresh->Visible=false;} 
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn5Click(TObject *Sender)
{
str="This option will overide the determination to 'accept of reject' a sound file, all sounds will be treated as 'accepted'";
str+=". This means that records will be added to the database and raw feature files will be saved, and so forth, regardless of the" ;
str+="content of the files. For example, even a file with one short syllable will be saved.";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::DirectoryListBox1Change(TObject *Sender)
{
  if(!data_type->ItemIndex)
  {
        soundList->ItemIndex=0;
       // identify_bird();
        return;
  }
  if(FileListBox1->Items->Strings[0]=="[..]" || FileListBox1->Items->Strings[0]=="[.]")FileListBox1->Items->Delete(0);
  if(FileListBox1->Items->Strings[0]=="[..]" || FileListBox1->Items->Strings[0]=="[.]")FileListBox1->Items->Delete(0);
  if(FileListBox1->Items->Count)
  {
   FileListBox1->ItemIndex=0;
   FileListBox1Click(this);
   soundList->Directory=active_folder->Text;
  }
  else soundList->Clear();
  if(soundList->Items->Count)soundList->ItemIndex=0;

}
//---------------------------------------------------------------------------


void __fastcall Tbatch::FileListBox1Change(TObject *Sender)
{
  soundList->Directory=active_folder->Text;
  soundList->ItemIndex=0;
  if(slave_list1->ItemIndex)set_slave_directory(1, slave_list1, folder_name1);
  if(slave_list2->ItemIndex)set_slave_directory(2, slave_list2, folder_name2);
  if(slave_list3->ItemIndex)set_slave_directory(3, slave_list3, folder_name3);
  if(slave_list4->ItemIndex)set_slave_directory(4, slave_list4, folder_name4);
  if(slave_list5->ItemIndex)set_slave_directory(5, slave_list5, folder_name5);
  if(slave_list6->ItemIndex)set_slave_directory(6, slave_list6, folder_name6);
  if(slave_list7->ItemIndex)set_slave_directory(7, slave_list7, folder_name7);
  if(slave_list8->ItemIndex)set_slave_directory(8, slave_list8, folder_name8);
  // identify_bird();

}
//---------------------------------------------------------------------------

void __fastcall Tbatch::FileListBox1Click(TObject *Sender)
{
  AnsiString str=FileListBox1->FileName;
  int i=1; do{if(str[i]=='[' || str[i]==']') str.Delete(i,1); i++;}while(i<=str.Length());
  str+="\\";
  active_folder->Text=str;
  soundList->ItemIndex=0;
  soundList->Directory=active_folder->Text;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::resegmentClick(TObject *Sender)
{
  breakIt->Enabled=true;
  total_count=0;
  save1->ItemIndex=1; // save syllable tables only
  option->create_feature_arrays=false;
  Get_raw_Table_attributes(); // retrieve simple attributes such as table name, number of records, etc.
  st->Brush->Color=clRed;
  status->Caption="executing batch";
  st->Repaint();
  batch->Repaint();
  batch->Refresh();
  AnsiString SyllTable=RecordFile1->Caption;
  option->create_feature_arrays=false;
  database=DataForm->MyConnection1->Database;
  table_batch=true;
  change_the_table=false;
  batch_controls->ActivePage=progress;
  get_age();
  doit=true;
}


//---------------------------------------------------------------------------


void __fastcall Tbatch::open_raw_tableClick(TObject *Sender)
{
  DataForm->openTableClick(this);
  DataForm->showTables();
  tables->Clear();
  DataForm->MyQuery1->First();
  for (int i=0; i < DataForm->MyQuery1->RecordCount; i++)
    {
     tables->Items->Add( DataForm->MyQuery1->Fields->Fields[0]->AsString);
     DataForm->MyQuery1->Next();
    }
    tables->ItemIndex=0;
   // Get_raw_Table_attributes();
}
//---------------------------------------------------------------------------





void Tbatch::Get_raw_Table_attributes()
{
      option->move_sound=false;
      // find raw table name, database, and number of records in the table
      DataForm->TheTable->Active=false;
      DataForm->TheTable->TableName= table_batch_list->Items->Strings[table_batch_list->ItemIndex];
      Raw_Table=DataForm->TheTable->TableName;
      DataForm->TheTable->Active=true;
      //DataForm->CountRecsClick(this);
      recnum=DataForm->count_records(table_batch_list->Items->Strings[table_batch_list->ItemIndex]);//DataForm->recNum;
      raw_features_database=DataForm->MyConnection1->Database;
      DataForm->initiate_handler(raw_features_database, Raw_Table); // open the handler for the table, go to first record...
     if(option->syllable_table_name.Length())
     {
      DataForm->TheTable->Active=false;
      DataForm->TheTable->TableName=option->syllable_table_name;
      DataForm->TheTable->Active=true;
      }// go back to the syllable table


}

void Tbatch::Get_brain_table_attribute()
{
       option->move_sound=false;
      // find raw table name, database, and number of records in the table
      DataForm->TheTable->Active=false;
      DataForm->TheTable->TableName= multi_tables_list->Items->Strings[multi_tables_list->ItemIndex];
      Raw_Table=DataForm->TheTable->TableName;
      DataForm->TheTable->Active=true;
      //DataForm->CountRecsClick(this);
      recnum=DataForm->count_records(multi_tables_list->Items->Strings[multi_tables_list->ItemIndex]);//DataForm->recNum;
      raw_features_database=DataForm->MyConnection1->Database;
      DataForm->initiate_handler(raw_features_database, Raw_Table); // open the handler for the table, go to first record...

     if(option->syllable_table_name.Length())
     {
      DataForm->TheTable->Active=false;
      DataForm->TheTable->TableName=option->syllable_table_name;
      DataForm->TheTable->Active=true;
     }
     //get_age();
}

/*
   This function take advantage of the CZT_featureCalc utility fucntions to generate syllable table the raw
   feature tables
   1. retrieve epochs of 50000 records from the raw table into a querry
   2. retrieve one record at a time from the querry into the m_ variables
   3. call parse_sound() in CZT_featureCalc, as we do usually with wave file analyzed -- that's it!
   The only other issue this function needs to follow is the stitching points from one wave file to the next
   in the raw features table
*/
void Tbatch::do_table_batch()
{
   st->Brush->Color=clRed;
   status->Caption="executing batch";
   int old_file_index=-1;
   static int current_rec=0, cumulative_rec=0, file_index=-999; // raw features are saved in raw feature tables, that contain 1ms features
   // data across many epochs of data. Each epoch is derived from one sound file. Those are the 'embeded file data'.
   // Let change_table, be an index of a record within an embeded file in the raw-features table
   static bool change_the_table=false;
   // we change table once a table analysis is complete, move to the next one in the listbox.
   m_Calculator.features.bird_ID=birdname->Text;
   option->bird_ID=birdname->Text;
   if(change_the_table)
   {
      if(table_batch_list->ItemIndex<table_batch_list->Items->Count-1)
      {
        get_age();
        //option->day++;
        table_batch_list->ItemIndex++;
        Get_raw_Table_attributes();
        cumulative_rec=0;
        current_rec=0; // this will be the first record of the new embeded sound file we discovered
        change_the_table=false;
      }
      else // no more tables to do...
      
      {
         doit=false; // finish the batch
         table_batch=false;
         st->Brush->Color=clGreen;
         status->Caption="The batch is now complete";
         option->create_feature_arrays=true;
      }
   }// end if(change_table)
   if(doit==false)return;

   // this is the main loop of calculations (within a daily raw table):
   int iterations; // these are iteration loops of 50000 iterations, that break the table to smaller units.
   short unsigned Year, Month, Day;
   // When the user clicks break, this loop will still finish its execution and then the batch stops.
   if(recnum-cumulative_rec>50000) iterations=50000; // normal case
   else {iterations=recnum-cumulative_rec; change_the_table=true;} // This is the end of the table.
   //next time we need to change the table
   DataForm->get_recs(Raw_Table, iterations); // place the next epoch of (usually 50,000) records in the myQuerry
   for(int i=1;i<iterations;i++) // we now process those records:
   {
       file_index=m_Calculator.msTable_to_vars(i);// copy data from the raw table myQuerry[i] to the m_ variables
       //double tt=tm;
       if(file_index!=old_file_index)// we detected a new_embeded_file in the raw features table -- reset the file variables
       {
            counter->Caption=m_Calculator.save_and_reset();// this function judge if time is continuues or not in this record
            current_rec=0;  // did we reset everthinging?
            option->wave_names[0]=DataForm->GetFileName(DataForm->file_table_name, file_index);//(option->file_table, file_index);
            m_Calculator.features.serial_number=DataForm->GetFile_serial(DataForm->file_table_name, file_index);
            if(option->age_in_table)
            {
              m_Calculator.features.day=(int)m_Calculator.features.serial_number-bird_hatched;
              m_Calculator.features.month=-1;
            }
            else // day is day of month, month is month
            {
              DecodeDate(m_Calculator.features.serial_number, Year, Month, Day);
              m_Calculator.features.day=Day;
              m_Calculator.features.month=Month;
            }
       }
       else
       {
            m_Calculator.parse_sound(current_rec);
            cumulative_rec++; current_rec++;
       }
       old_file_index=file_index;
   //    else {cumulative_rec++; current_rec++;}
   }
}

      //  m_Calculator.raw_to_vars(Raw_Table, counter, recnum); // gives m_vars
 /*
 void Tbatch::initiate_handler()
 {
        // open databse
        str="use ";
        str+=raw_features_database;
        DataForm->MyCommand1->SQL->Clear();
        DataForm->MyCommand1->SQL->Add(str);
        DataForm->MyCommand1->Execute(1);

        // open the table
        str="HANDLER `";
        str+=Raw_Table;
        str+="` open;";
        DataForm->MyCommand1->SQL->Clear();
        DataForm->MyCommand1->SQL->Add(str);
        DataForm->MyCommand1->Execute(1);

        // go to the begining
        str="HANDLER `";
        str+=Raw_Table;
        str+="` read first limit 1;";
        DataForm->MyCommand1->SQL->Clear();
        DataForm->MyCommand1->SQL->Add(str);
        DataForm->MyCommand1->Execute(1);
}

    
 void Tbatch::get_raw_recs(int i)
 {
    str="HANDLER `";
    str+=Raw_Table;
    str+="` read next limit ";
    str+=i; str+=";";
    DataForm->MyQuery1->SQL->Clear();
    DataForm->MyQuery1->SQL->Add(str);
    DataForm->MyQuery1->Execute();
    DataForm->MyQuery1->First();
    DataForm->MyQuery1->RecordCount;
 }
    */



 bool Tbatch::new_embeded_file(TDateTime tm)
 {
    static TDateTime old_tm=0;
    unsigned short year1, month1, day1, Hour1, Min1, Sec1, Msec1;
    bool new_epoch=false;
    if((double)tm-(double)old_tm>0.00001)
    {
        new_epoch=true;
        tm.DecodeDate(&year1, &month1, &day1);
        tm.DecodeTime(&Hour1, &Min1, &Sec1, &Msec1);
        option->serial_number=tm;
        option->month=month1;
        option->day=day1;
        option->hour=Hour1;
        option->minute=Min1;
        option->second=Sec1;
    }
    old_tm=tm;
    return(new_epoch);
 }


  int Tbatch::count_slaves()
  {
    int cnt=0;
    if(slave_state1->ItemIndex)cnt++;
    if(slave_state2->ItemIndex)cnt++;
    if(slave_state3->ItemIndex)cnt++;
    if(slave_state4->ItemIndex)cnt++;
    if(slave_state5->ItemIndex)cnt++;
    if(slave_state6->ItemIndex)cnt++;
    if(slave_state7->ItemIndex)cnt++;
    if(slave_state8->ItemIndex)cnt++;
    return(cnt);
  }




void __fastcall Tbatch::hatchedChange(TObject *Sender)
{
  DataForm->Settings(1, "hatching_date", FormatDateTime(hatched->Date,1));
}
//---------------------------------------------------------------------------




int Tbatch::lookfor_slave_files()
{
  AnsiString Slave_name, slv_state, str1;
  TRadioGroup *slave_state[8];
  TFileListBox *slave_list[8];

  slv_state="";
  deduct=false;
  slave_state[0]=slave_state1;  slave_state[1]=slave_state2;  slave_state[2]=slave_state3;  slave_state[3]=slave_state4;
  slave_state[4]=slave_state5;  slave_state[5]=slave_state6;  slave_state[6]=slave_state7;  slave_state[7]=slave_state8;

  slave_list[0]=slave_list1;    slave_list[1]=slave_list2;    slave_list[2]=slave_list3;    slave_list[3]=slave_list4;
  slave_list[4]=slave_list5;    slave_list[5]=slave_list6;    slave_list[6]=slave_list7;    slave_list[7]=slave_list8;
  int num_chan=0;
  for(int i=0;i<8;i++)
       {
           if(slave_state[i]->ItemIndex)
           {
             int diff, files_waiting=slave_list[i]->Items->Count;
             num_chan++;
            // slave_list[i]->Update();
             if(!slave_list[i]->Items->Count)
             {
                current_slave->Caption="no slave files available";
                return(false); // nothing to do until the file shows up...
             }
             
             // we are now looking for matching files:
            // slave_list[i]->ItemIndex=0;
            if(slave_list[i]->ItemIndex>files_waiting-2)// we are more or less at the end of the list
            {
              slave_list[i]->ItemIndex=0;// we should search from the beginning of the list...
            }
            if(slave_list[i]->ItemIndex>0)slave_list[i]->ItemIndex--; // go one back, just in case...
            bool found_slave_match=false;
            for(int j=slave_list[i]->ItemIndex; j<files_waiting; j++)
            {
                str= ExtractFileName(SoundFile);
                str=str.SubString(str.Length()-char_comp->Value,char_comp->Value-3);//20, 17);
                //str=str.SubString(4, str.Length()-3);
                str1=ExtractFileName(slave_list[i]->FileName);
                str1=str1.SubString(str1.Length()-char_comp->Value,char_comp->Value-3);//20, 17);
                // str1=str1.SubString(4, str1.Length()-3);
                diff=str.AnsiCompare(str1);
                if(!diff){found_slave_match=true; Slave_name= slave_list[i]->FileName; break;}
                slave_list[i]->ItemIndex++;
            }
            if(found_slave_match)
            {
                slv_state+="slave ";
                slv_state+=i;
                slv_state+=" + ";
                current_slave->Caption=slv_state;
                option->wave_names[i+1]=Slave_name;
                if(wave_files[i+1].OpenFile(Slave_name.c_str())== pcmpos_error )return(false);
                    // else file_ch[i]->Caption=ExtractFileName(FileListBox[i]->FileName);
            }
            else  //return(false); // try again later...
            {
                //if(i==0) return(false);
                slv_state+="slave ";
                slv_state+=i;
                slv_state+=" - ";
                current_slave->Caption=slv_state;
                if(i==1) {deduct=true; return(1);}// could not find match to flow channels deduct it...
                else return(false);

            }
           }
       }
       return(num_chan);
}



 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void __fastcall Tbatch::slave_state1Click(TObject *Sender)
{
         if(Sender==slave_state1) { set_slave_directory(1, slave_list1, folder_name1);  option->slave_mode[0]=slave_state1->ItemIndex; }
    else if(Sender==slave_state2) { set_slave_directory(2, slave_list2, folder_name2);  option->slave_mode[1]=slave_state2->ItemIndex; }
    else if(Sender==slave_state3) { set_slave_directory(3, slave_list3, folder_name3);  option->slave_mode[2]=slave_state3->ItemIndex; }
    else if(Sender==slave_state4) { set_slave_directory(4, slave_list4, folder_name4);  option->slave_mode[3]=slave_state4->ItemIndex; }
    else if(Sender==slave_state5) { set_slave_directory(5, slave_list5, folder_name5);  option->slave_mode[4]=slave_state5->ItemIndex; }
    else if(Sender==slave_state6) { set_slave_directory(6, slave_list6, folder_name6);  option->slave_mode[5]=slave_state6->ItemIndex; }
    else if(Sender==slave_state7) { set_slave_directory(7, slave_list7, folder_name7);  option->slave_mode[6]=slave_state7->ItemIndex; }
    else if(Sender==slave_state8) { set_slave_directory(8, slave_list8, folder_name8);  option->slave_mode[7]=slave_state8->ItemIndex; }


}
//---------------------------------------------------------------------------




bool Tbatch::set_slave_directory(int slave_num, TFileListBox* slave_list, TEdit* folder_name)
{
    AnsiString str1;
    if(automate_slave_find->ItemIndex) // slave folders are in subdirectories //slave1, slave2...
    {
    str=FileListBox1->Directory;
    char c=str[str.Length()];
    if(!(c=='\\'))
    {
        str+="\\";
    }
    str1=ExtractFileName(FileListBox1->FileName);
    str1=str1.SubString(2,str1.Length()-2);
    str+=str1;
    str+="\\slave";
    str+=slave_num;
    }
    else   // subdirectories are manually specified.
    {
       str=folder_name->Text;
    }

    if(DirectoryExists(str)) { slave_list->Directory=str; folder_name->Text=str; slave_list->Update(); slave_list->ItemIndex=0; return(true);}
    else return(false);

}

void __fastcall Tbatch::formatClick(TObject *Sender)
{
  option->format->ItemIndex=format->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::yearChange(TObject *Sender)
{
  option->year=year->Text.ToInt();
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::new_file_tableBClick(TObject *Sender)
{
  DataForm->new_file_tableBClick(this);
  file_table_name->Caption=DataForm->file_table_name;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn1Click(TObject *Sender)
{
        str="The slave channels will typically include wave files generated in conjunction with";
        str+="the sound file, such as presure date, electrophysiology recordings, etc. Each of the";
        str+="associated file must be placed in a subfolder of the sound files and named 'Slave1',";
        str+="'Slave2.,... Setting folders manually will not update when master folder has changed";
        MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::automate_slave_findClick(TObject *Sender)
{
  if(!automate_slave_find->ItemIndex)
  {
        folder_name1->Enabled=true;  folder_name1->Color=clWhite;
        folder_name2->Enabled=true;  folder_name2->Color=clWhite;
        folder_name3->Enabled=true;  folder_name3->Color=clWhite;
        folder_name4->Enabled=true;  folder_name4->Color=clWhite;
        folder_name5->Enabled=true;  folder_name5->Color=clWhite;
        folder_name6->Enabled=true;  folder_name6->Color=clWhite;
        folder_name7->Enabled=true;  folder_name7->Color=clWhite;
        folder_name8->Enabled=true;  folder_name8->Color=clWhite;
  }
  else
  {
        folder_name1->Enabled=false;  folder_name1->Color=clBtnFace;
        folder_name2->Enabled=false;  folder_name2->Color=clBtnFace;
        folder_name3->Enabled=false;  folder_name3->Color=clBtnFace;
        folder_name4->Enabled=false;  folder_name4->Color=clBtnFace;
        folder_name5->Enabled=false;  folder_name5->Color=clBtnFace;
        folder_name6->Enabled=false;  folder_name6->Color=clBtnFace;
        folder_name7->Enabled=false;  folder_name7->Color=clBtnFace;
        folder_name8->Enabled=false;  folder_name8->Color=clBtnFace;
  }
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::ApplicationEvents1Idle(TObject *Sender, bool &Done)
{
    batch->Update();
    try{


        if(counting){back_count--; if(back_count<1){counting=false; doit=false;}} // this will set a limit to number of operations in do next x files mode
        if(table_batch && doit) do_table_batch();
        else if(soundList->ItemIndex<soundList->Items->Count-1 && doit)
                processFile(); // make a step, processing next file
        else if(doit) // All the files in the folder where processed
        {
            if(All_subfolders->Checked)// continue across all subfolders
            {
              if(FileListBox1->ItemIndex<FileListBox1->Items->Count-1)
              {
                 FileListBox1->ItemIndex++; // change subfolder
                 FileListBox1Click(this);   // get the files exstracted to 'soundlist'
                 FileListBox1Change(this);
                 //Sleep(20);
                 FileListBox1->Refresh();
                 //Sleep(100);
                 FileListBox1Change(this);
                // option->extract_file_attributes();

                // set_slave_directory(1, slave_list1, folder_name1);
                // option->slave_mode[0]=slave_state1->ItemIndex;


              }
              else
              {
                doit=false;  // finish the batch
                status->Caption="The batch is now complete";
                //batch_controls->Visible=true;
                stop = GetTickCount();
                int dur=stop-start;
                AnsiString sMessage;
                sMessage.printf("done within %d seconds",dur/1000);
                MessageDlg(sMessage.c_str(), mtInformation, TMsgDlgButtons() << mbOK, 0);
                RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
              }
            }

            else
            {
              st->Brush->Color=clGreen;
              //batch_controls->Visible=true;
              status->Caption="The batch is now complete";
              doit=false;
              stop = GetTickCount();
              int dur=stop-start;
              AnsiString sMessage;
              sMessage.printf("done within %d seconds",dur/1000);
              MessageDlg(sMessage.c_str(), mtInformation, TMsgDlgButtons() << mbOK, 0);
              RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
            }
        }
     }catch(...)
       {
           doit=false;
           MessageDlg("an exception has occured, could not finish the batch",mtWarning, TMsgDlgButtons() << mbOK, 0);
       }
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::addClick(TObject *Sender)
{
   TListBox *list;
   list=table_batch_list;
   for(int i=0; i<tables->Items->Count; i++)
       if(tables->Selected[i])list->Items->Add(tables->Items->Strings[i]);//soundList->FileName);
   list->ItemIndex=0;
   Get_raw_Table_attributes();
   get_age();
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::table_batch_listMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    Get_raw_Table_attributes();
    get_age();
  //  age->Value=ageTb->Position+table_batch_list->ItemIndex;
        //table_batch_list->Items->Strings[table_batch_list->ItemIndex].ToIntDef(1);
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::table_batch_listKeyPress(TObject *Sender,
      char &Key)
{
    if(Key==46 || Key==110 || Key=='d')  table_batch_list->Items->Delete(table_batch_list->ItemIndex);
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::open_file_tableClick(TObject *Sender)
{
   DataForm->openTableClick(this);
   DataForm->file_table_name=DataForm->TheTable->TableName;
}
//---------------------------------------------------------------------------



void Tbatch::get_age()
{
        str=table_batch_list->Items->Strings[table_batch_list->ItemIndex];
        int i=1;
        do{i++;}while(str[i]!='_' && i<str.Length()); // takes us to the "_"
        i++; // path it to the age part of the name
        str=str.SubString(i,str.Length());
        option->day=str.ToIntDef(0);
}



void __fastcall Tbatch::openTableClick(TObject *Sender)
{
  batch->Enabled=true;
  batch_count->Enabled=true;
  database=DataForm->MyConnection1->Database;
  DataForm->TheTable=DataForm->Records;
  DataForm->openTableClick(this);
  bird_name->Caption=DataForm->TheTable->TableName;
  update_table_names();
}
//---------------------------------------------------------------------------

   
void __fastcall Tbatch::open_file_tblClick(TObject *Sender)
{
  DataForm->open_FILE_tableClick(this);
  file_table_name->Caption=DataForm->file_table_name;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::auto_file_tableClick(TObject *Sender)
{
  if(auto_file_table->Checked)
  {new_file_tableB->Visible=false; open_file_tbl->Visible=false;}
  else
  {new_file_tableB->Visible=true; open_file_tbl->Visible=true;}
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::play_listClick(TObject *Sender)
{
  if(play_list->Down)playbacks_timer->Enabled=true;
  else playbacks_timer->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::playbacks_timerTimer(TObject *Sender)
{
	 //play->Wave->FileName=soundList->FileName;
	 //play->Play();
	 //soundList->ItemIndex++;
	 //playbacks_timer->Interval= play->Wave->DataSize/70;
}
//---------------------------------------------------------------------------


void Tbatch::identify_bird()
{
     if(soundList->FileName=="")return;
     if(DataForm->retrieve_animal(ExtractFileName(soundList->FileName)))
     {
        bird_hatched=FormatDateTime(DataForm->MyQuery1->FieldValues["hatched"],1);
        //TDateTime file_age=file_age.FileDateToDateTime(FileAge(soundList->FileName));
       // int the_age=file_age-bird_hatched;
       int the_age=option->file_age-bird_hatched;
        if(the_age<0 || the_age>99999)
        {
          bird_name->Caption="none";
          age->Caption="0";
          model->Caption="none";
          training_age->Caption="0";
          details->Caption="none";
        }
        else
        {
          bird_name->Caption=DataForm->MyQuery1->FieldValues["bird_name"];
          age->Caption=the_age;
          model->Caption=DataForm->MyQuery1->FieldValues["model"];
          training_age->Caption=DataForm->MyQuery1->FieldValues["training"]-DataForm->MyQuery1->FieldValues["hatched"];
          details->Caption=DataForm->MyQuery1->FieldValues["details"];
          hatched->Date=bird_hatched;
          if(auto_name) update_table_names();
        }
     }
     else
     {
          bird_name->Caption="none";
          age->Caption="0";
          model->Caption="none";
          training_age->Caption="0";
          details->Caption="none";
     }
}
void __fastcall Tbatch::age_or_dayClick(TObject *Sender)
{
  if(age_or_day->ItemIndex) option->age_in_table=false;
  else option->age_in_table=true; 
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::char_comp_tbChange(TObject *Sender)
{
  char_comp->Value=char_comp_tb->Position;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::new_birdClick(TObject *Sender)
{
  batch->Enabled=true;
  batch_count->Enabled=true;
  if(Sender==new_bird) animals_form->datapages->ActivePageIndex=1;
  else animals_form->datapages->ActivePageIndex=0;
  if (animals_form->ShowModal() == mrOk)
  {
    bird_name->Caption=animals_form->name->Text;
    age->Caption=animals_form->age->Value;
    model->Caption=animals_form->song->Text;
    training_age->Caption=animals_form->training->Text;
    details->Caption=animals_form->bird_comments->Text;
    update_table_names();
  }
  if(animals_form->new_bird) animals_form->Insert_bird_record();
  hatched->Date=animals_form->hatched->Date;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::change_raw_tableClick(TObject *Sender)
{
  str=DataForm->open_Raw_Table();
  raw_features1->Text=str;
  ms_table_name->Caption=str;
  option->features_table=str;

}
//---------------------------------------------------------------------------

void Tbatch::update_table_names()
{
  RecordFile1->Caption="syll_" + bird_name->Caption;
  DataForm->Create_table(RecordFile1->Caption);
  DataForm->TheTable->TableName=RecordFile1->Caption;
  RecordsNum->Caption=DataForm->count_records(option->syllable_table_name);
  option->syllable_table_name=DataForm->TheTable->TableName;
  syllable_table_name->Caption=option->syllable_table_name;
  int bird_age= option->file_age - (int)hatched->Date;
  if(bird_age<0)bird_age=0;

  str="raw_" + bird_name->Caption +"_" + bird_age;
  if((option->saveRawFile && (save1->ItemIndex==0 || save1->ItemIndex==2)) && !DataForm->table_exists(str))
  {
        m_Calculator.last_ms_record=0;
        str=DataForm->new_raw_table(str,slave_chans);
        raw_features1->Text=str;
        ms_table_name->Caption=str;
        option->features_table=str;
  }
}




void __fastcall Tbatch::SyllMinDurTbChange(TObject *Sender)
{
     option->syllable_duration_thresh=1.4*SyllMinDurTb->Position;
     SyllDurLow->Value=option->syllable_duration_thresh;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BoutMinDurTBChange(TObject *Sender)
{
  option->bout_duration_thresh=1.4*BoutMinDurTB->Position;
  BoutDurLow->Value=option->bout_duration_thresh;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::min_syllablesChange(TObject *Sender)
{
   option->minimum_syllables_per_files=min_syllables->Position;
   mean_syllable_num->Value=option->min_syllables->Position;
}
//---------------------------------------------------------------------------



void __fastcall Tbatch::BitBtn8Click(TObject *Sender)
{
  batch_controls->ActivePage=TabSheet1;      
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn11Click(TObject *Sender)
{
   Application->HelpContext(60);        
}
//---------------------------------------------------------------------------




void __fastcall Tbatch::state_transition_TBChange(TObject *Sender)
{
        state_transition_Num->Value=(float)state_transition_TB->Position/10.0;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::missmatchesTbChange(TObject *Sender)
{
        missmatchesNum->Value=missmatchesTb->Position;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn12Click(TObject *Sender)
{
  str="State duration data are saved into the table state_duration";
  str+="Note that each batch adds data to this table.";
  str+="You need to empty it via the MySQL control center";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::open_multitabler_databaseClick(TObject *Sender)
{
  DataForm->openTableClick(this);
  DataForm->showTables();
  tables->Clear();
  DataForm->MyQuery1->First();
  for (int i=0; i < DataForm->MyQuery1->RecordCount; i++)
    {
     multi_tables->Items->Add( DataForm->MyQuery1->Fields->Fields[0]->AsString);
     DataForm->MyQuery1->Next();
    }
    multi_tables->ItemIndex=0;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::add2Click(TObject *Sender)
{
   // TListBox *list;
   //list=multi_tables_list;
   for(int i=0; i<multi_tables->Items->Count; i++)
       if(multi_tables->Selected[i])multi_tables_list->Items->Add(multi_tables->Items->Strings[i]);//soundList->FileName);
  multi_tables_list->ItemIndex=0;
  Get_brain_table_attribute();
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::multi_tables_listKeyPress(TObject *Sender,
      char &Key)
{
if(Key==46 || Key==110 || Key=='d')  multi_tables_list->Items->Delete(multi_tables_list->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::multi_tables_listMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
      Get_brain_table_attribute();
}

//---------------------------------------------------------------------------

void __fastcall Tbatch::segment_byClick(TObject *Sender)
{
  TRChart *chart;
  TRadioGroup *segment;
  if(Sender==segment_by)
  {
        chart=multi_chart;
        segment=segment_by;
  }
  else
  {
        chart=multi_chart2;
        segment=segment_by2;
  }

  //multi_chart->MouseAction=maZoomDrag;
  switch(segment->ItemIndex)
  {
        case 0: chart->Scale1Y->RangeLow=0; chart->Scale1Y->RangeHigh=100; break;
        case 1: chart->Scale1Y->RangeLow=-10; chart->Scale1Y->RangeHigh=0; break;
  }
  chart->ClearGraf();
  chart->DataColor=clBlue;

  if(!got_data)
  {
        DataForm->get_recs(Raw_Table, 5000); // place the next epoch of (usually 50,000) records in the myQuerry
        got_data=true;
  }

  for(int i=1;i<5000;i++) // we now process those records:
  {
    m_Calculator.msTable_to_vars(i);
    float y;
    switch(segment->ItemIndex)
    {
        case 0:y=m_Calculator.m_amplitude; break;
        case 1:y=m_Calculator.m_Entropy; break;
        case 2: y=m_Calculator.m_AM; break;
        case 3: y=m_Calculator.m_s1_amplitude; break;
        case 4: y=m_Calculator.m_s1_entropy; break;
        case 5: y=m_Calculator.m_s1_peak_frequency; break;
        case 6: y=m_Calculator.m_s2_amplitude; break;
        case 7: y=m_Calculator.m_s2_entropy; break;
        case 8: y=m_Calculator.m_s2_peak_frequency; break;
    }

    chart->MarkAt(i,y,1);
  }
  chart->ShowGraf();
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::forwardClick(TObject *Sender)
{
  got_data=false;
  segment_byClick(this);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::resetClick(TObject *Sender)
{
   DataForm->initiate_handler("sap", Raw_Table);
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::multi_segmentClick(TObject *Sender)
{
  option->brain_mode=true;
  breakIt->Enabled=true;
  total_count=0;
  save1->ItemIndex=1; // save syllable tables only
  option->create_feature_arrays=false;
  Get_raw_Table_attributes(); // retrieve simple attributes such as table name, number of records, etc.
  st->Brush->Color=clRed;
  status->Caption="executing batch";
  st->Repaint();
  batch->Repaint();
  batch->Refresh();
  AnsiString SyllTable=RecordFile1->Caption;
  option->create_feature_arrays=false;
  database=DataForm->MyConnection1->Database;
  table_batch=true;
  option->custom_parse=true;
  change_the_table=false;
  option->segmentation_feature=segment_by->ItemIndex;
  option->custom_segmentation_thresh=custom_thresh->Text.ToDouble();
  batch_controls->ActivePage=progress;
  get_age();
  doit=true;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::create_braintableClick(TObject *Sender)
{
  batch->Enabled=true;
  batch_count->Enabled=true;
  database=DataForm->MyConnection1->Database;
  DataForm->new_brain_tableClick(this);
  bird_name->Caption=DataForm->TheTable->TableName;
  update_table_names();
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::BitBtn7Click(TObject *Sender)
{
  str=" The 'do it all' button is initially inactive (gray).";
  str+="Before starting the batch you need to identify the bird: click 'new bird'.";
  str+="or 'add bird', and make sure all options are set before starting the batch";
  MessageDlg(str, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tbatch::brain_tableClick(TObject *Sender)
{
 if(brain_table->ItemIndex)
 {
        // if needed, create brain tables
        option->brain_mode=true;
 }
 else option->brain_mode=false;//Add_Brain_Record();
}



//---------------------------------------------------------------------------




void __fastcall Tbatch::calc_rhythmClick(TObject *Sender)
{
int range, samp;
static int slice=1, counter=0;
static bool first_time=true;
static float RR[500];
if(first_time) for(int i=0;i<500;i++) {RR[i]=0; first_time=false;}


  switch(rhythm_range->ItemIndex)
  {
          case 0: range=200; samp=2; break;
          case 1: range=500; samp=5; break;
          case 2: range=5000; samp=50; break;
  }

  float* r=m_Calculator.Calculate_rhythm(rhythm_range->ItemIndex, rhythm_feature->ItemIndex, rhythm_filter->ItemIndex);

  rhythm_chart->ClearGraf();
  rhythm_chart->DataColor=clRed;
  rhythm_chart->MoveTo(0,0);
  float Xr, maxY=0;
  str="";
  rhythm_spect->GridMat->Resize(range,100);
  rhythm_spect->MeshVisible=false;

  counter++;
  for(int i=1;i<range;i++) // we now process those records:
  {
    Xr=(float)i*0.030517578/option->advanceTb->Value;
    rhythm_chart->DrawTo(Xr,r[i]);
    if(maxY<r[i])maxY=r[i];
    if(counter<10)RR[i]+=r[i];
    else rhythm_spect->GridMat->Elem[i][slice]=(int)(RR[i]/20);
  }
  if(counter==10)
  {
        counter=0;
        slice++;
        for(int i=0;i<500;i++)RR[i]=0;
        rhythm_spect->Refresh();
  }
  //if(print_rhythm->Checked)rhythm_data->Lines->Add(str);
  rhythm_chart->Scale1X->RangeHigh=Xr;
  rhythm_chart->Scale1Y->RangeHigh=maxY;
  rhythm_chart->Scale1X->RangeLow=0;
  rhythm_chart->Scale1Y->RangeLow=0;
  rhythm_chart->ShowGraf();
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::zoomClick(TObject *Sender)
{
  switch(zoom->ItemIndex)
 {
     case 0:rhythm_chart->MouseAction=maZoomDrag; break;
     case 1:rhythm_chart->MouseAction=maPan; break;
     case 2:rhythm_chart->MouseAction=maZoomWind; break;
 }
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::colorsChange(TObject *Sender)
{
  rhythm_spect->ColorScaleHigh=colors->Position;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::angleXChange(TObject *Sender)
{
  rhythm_spect->ViewAngleX=angleX->Position;
}
//---------------------------------------------------------------------------

void __fastcall Tbatch::angleZChange(TObject *Sender)
{
  rhythm_spect->ViewAngleZ=angleZ->Position;
}
//---------------------------------------------------------------------------

