//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <math.h>

#include "open_soundD.h"
//---------------------------------------------------------------------
#pragma link "SDL_NumLab"
#pragma resource "*.dfm"
Topen_sound *open_sound;
//--------------------------------------------------------------------- 
__fastcall Topen_sound::Topen_sound(TComponent* AOwner)
	: TOKBottomDlg(AOwner)
{
  sampling_rate=44100;
}
//---------------------------------------------------------------------
void __fastcall Topen_sound::HelpBtnClick(TObject *Sender)
{
	Application->HelpContext(HelpContext);
}
//---------------------------------------------------------------------
void __fastcall Topen_sound::sound_listClick(TObject *Sender)
{
  OKBtn->Enabled=true;
  wave.ResetContents();
  m_Calculator1.brightness=gain->Position*0.000001;
   //active_view=true;
   //GUI=true;
   m_Calculator1.newFile=sound_list->FileName;
   CZT_PcmEq equalizer;
   //wave.UseFilter(equalizer);
   m_Calculator1.RenderImage(1);
   m_Calculator1.render_image=true;
   AnsiString str=sound_list->FileName;
   if(wave.OpenFile(str.c_str())==pcmpos_error)
   {
    invalid->Visible=true;
	OKBtn->Enabled=false;
   }
   //Application->MessageBox(L"Error: could not open wave file", NULL, MB_OK);// != pcmpos_error)
   else
   {
		  OKBtn->Enabled=true;
		  int i=wave.GetTotalSamples();
          int dur=i/44100;
		  if(dur>50)too_long->Visible=true;
		  else too_long->Visible=false;
		  duration->Caption=dur;
          sampling_rate=wave.m_WaveHeader.nSamplesPerSec;
          sampling->Caption=sampling_rate;
          option->sampling_rate=sampling_rate;
          frequency_rangeChange(this);
          data_windowChange(this);
          advanceChange(this);

		  invalid->Visible=false;
          try{
          m_Calculator1.init_viewer(wave);
          }
          catch(...)
          {Application->MessageBox(L"Error: could not innitiate", NULL, MB_OK);}

          try{  m_Calculator1.viewer(wave, 400, 1);}
          catch(...)
          {Application->MessageBox(L"Error: could not run viewer", NULL, MB_OK);}




		  m_Calculator1.GetImage().DrawViewerSlices(Image1);
		  m_Calculator1.GetImage().DrawViewerSlices(Image1);
		  if(playbacks->Checked)
		  {
			wave.ResetContents();
			play->FileName =sound_list->FileName;
			play->Open();
          }
   }
}
//---------------------------------------------------------------------------

void __fastcall Topen_sound::OKBtnClick(TObject *Sender)
{
  play->Close();
  wave.ResetContents();
  FileName=sound_list->FileName;
}
//---------------------------------------------------------------------------

void __fastcall Topen_sound::CancelBtnClick(TObject *Sender)
{
  play->Close();
  wave.ResetContents();
}
//---------------------------------------------------------------------------

void __fastcall Topen_sound::BitBtn1Click(TObject *Sender)
{
  if(open->Execute())
  {
	AnsiString str=open->FileName;
	DirectoryListBox1->Directory=ExtractFileDir(str);
	sound_list->FileName=open->FileName;
	sound_listClick(this);
  }
}
//---------------------------------------------------------------------------

void __fastcall Topen_sound::warningClick(TObject *Sender)
{
   if(warning->Checked)option->warning=true;
   else option->warning=false;
}
//---------------------------------------------------------------------------

void __fastcall Topen_sound::file_editChange(TObject *Sender)
{
     sound_list->ApplyFilePath(file_edit->Text);
}
//---------------------------------------------------------------------------



void __fastcall Topen_sound::sound_listDblClick(TObject *Sender)
{
  sound_listClick(this);
  OKBtnClick(this);
  open_sound->ModalResult=mrOk;
}
//---------------------------------------------------------------------------


void __fastcall Topen_sound::FormActivate(TObject *Sender)
{
  sound_list->Update();
  OKBtn->Enabled=false;
}
//---------------------------------------------------------------------------


void __fastcall Topen_sound::frequency_rangeChange(TObject *Sender)
{
  int i=pow(2,4-frequency_range->Position);
  frequency_range_val->Value=sampling_rate/i;
  Form1->frequency_range->Position=frequency_range->Position;
  Form1->frequency_range2->Position=frequency_range->Position;
  //Form1->frequency_rangeChange(this);
}
//---------------------------------------------------------------------------

void __fastcall Topen_sound::data_windowChange(TObject *Sender)
{
  windowTB->Value=1000.0*(float)data_window->Position/(float)sampling_rate;
  Form1->data_window->Position=data_window->Position;
  Form1->data_window2->Position=data_window->Position;
  //Form1->data_windowChange(this);
}
//---------------------------------------------------------------------------

void __fastcall Topen_sound::advanceChange(TObject *Sender)
{
  advanceTb->Value=1000.0*(float)advance->Position/(float)sampling_rate;
  Form1->advance->Position=advance->Position;
  Form1->advance2->Position=advance->Position;
  //Form1->advanceChange(this);
}
//---------------------------------------------------------------------------

